searchData={"items":[{"type":"module","title":"CanonicalHost","doc":"See [README](readme.html) for usage.","ref":"CanonicalHost.html"},{"type":"extras","title":"CanonicalHost","doc":"# CanonicalHost\n\n[![Package](https://img.shields.io/hexpm/v/canonical_host.svg)](https://hex.pm/packages/canonical_host) [![Documentation](http://img.shields.io/badge/hex.pm-docs-green.svg?style=flat)](https://hexdocs.pm/canonical_host) ![CI](https://github.com/balexand/canonical_host/actions/workflows/elixir.yml/badge.svg)\n\nPlug for redirecting all traffic to a canonical host.","ref":"readme.html"},{"type":"extras","title":"Installation - CanonicalHost","doc":"The package can be installed by adding `canonical_host` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:canonical_host, \"~> 0.2\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - CanonicalHost","doc":"```elixir\n# config/runtime.exs\nconfig :canonical_host, :default, host: \"https://myhost.com\"\n```\n\n```elixir\n# plug pipeline in router.ex or endpoint.ex\nplug CanonicalHost\n```\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Multiple canonical hosts - CanonicalHost","doc":"```elixir\n# config/runtime.exs\nconfig :canonical_host, :one, host: \"https://host-one.com\"\nconfig :canonical_host, :two, host: \"https://host-two.com\"\n```\n\n```elixir\n# one plug pipeline\nplug CanonicalHost, config_key: :one\n\n# another plug pipeline\nplug CanonicalHost, config_key: :two\n```","ref":"readme.html#multiple-canonical-hosts"},{"type":"extras","title":"Alternatives - CanonicalHost","doc":"### [`plug_canonical_host`](https://hex.pm/packages/plug_canonical_host)\n\nI chose to create a new library instead of using this library for the following reasons:\n\n1. Has awkward configuration. It is not convenient to configure at runtime. Instead, the [README](https://github.com/remi/plug_canonical_host/blob/master/README.md) suggests that you write your own function plug and then call both `PlugCanonicalHost.init/1` and `PlugCanonicalHost.call/2` in your function plug.\n2. Redirects HTTP requests with methods other than `GET`. Consider a case where an API client sends a `POST` request to your app at the non-canonical domain. `PlugCanonicalHost` will cause the request to not be handled but will return an HTTP `301` response which would make the client believe that the request succeeded.\n3. Tries to redirect with the same scheme (HTTP/HTTPS) and port number as the original request. I'd prefer to always redirect to the canonical scheme/host/port and save the user a possible extra redirect.","ref":"readme.html#alternatives"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}